/**
 * Copyright 2006 (C) Jeffrey Palm
 */

// --------------------------------------------------
// Variables
// --------------------------------------------------
var xmlhttp;                         // retrieves XML from my site
var tick;

// --------------------------------------------------
// Initialize the menu
// --------------------------------------------------

pluginHelper.onAddCustomMenuItems = function(menu) {
  menu.AddItem("Reset",0,gadgetReset);
}

// --------------------------------------------------
// Methods
// --------------------------------------------------

function view_onOpen() {
  gadgetReset();
}

function gadgetReset() {
  loadingImg.visible = false;
  setMainText("Please enter a\nticket symbol");
}

function setMainText(s) {
  mainContent.value = s;
  inputField.value = "GOOG";
}

/**
 * Void -> XMLHttp
 */
function createXMLThingy() {
  try {
    xmlhttp = new XMLHttpRequest();
    if (xmlhttp) return xmlhttp;
  } catch(e) {
    try {
      xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
      if (xmlhttp) return xmlhttp;
    } catch(e) {}
  }
  return xmlhttp;
}

function trace(s) {
  gadget.debug.trace(s);
}

function error(s) {
  gadget.debug.error(s);
}

function lookup() {
  trace("lookup");
  loadingImg.visible = true;
  //
  // sanity check
  //
  if (xmlhttp && xmlhttp.readyState != 0 && xmlhttp.readyState != 4) return;
  //
  // do the look up
  //
  xmlhttp = createXMLThingy();
  tick = inputField.value;
  if (!tick || tick == "") {
    inputField.value = tick = "GOOG";
  }
  url = "http://quote.yahoo.com/d/quotes.csv?s=" + tick + "&f=sl1d1t1c1ohgv&e=.csv";
  trace("sending url:" + url);
  xmlhttp.open("GET",url,true);
  xmlhttp.onreadystatechange = lookupDone;
  xmlhttp.send("");  
  trace("sent url:" + url);
}

function lookupDone() {
  trace("lookupDone");
  if(xmlhttp.readyState == 4 && xmlhttp.status == 200) {
    txt = xmlhttp.responseText;
    trace("text="+txt);
    parts = txt.split(",");
    var s = "TuxQuote for: " + tick;
    s += "\nMost recent trade: $" + parts[1];
    s += "\nChange: " + parts[4];
    setMainText(s);
  } else if( xmlhttp.readyState == 4 ){
    error("HTTP status:" + xmlhttp.status);
  }
  loadingImg.visible = false;
}
